/*******************************************************************************
*                                                                              *
*******************************************************************************/
void Init_Const (void)
{
    PORTD |= ((1<<4) | (1<<5) | (1<<6) | (1<<7));
    DDRD  |= ((1<<4) | (1<<5) | (1<<6) | (1<<7));

    PORTA = 0xFF;
    DDRA  = 0xFC;
}
/******************************************************************************/
void Vym (void)
{
// for U2
  static unsigned char   my_marker;

    if (global_marker == 0)
    {
        if ((PINA & 0x01) == 0)
        {
          global_marker = 1;
          my_marker = 1;
          TWI_targetSlaveAddress = SLA_W_ADC;
          command_twi = RD_TWI_SLAVE;
          number_byte_wr_slave = 2;
          number_byte_rd_slave = 2;
          byte_addr_comm = 0x01;
        }
    }

    else
    {
        if (my_marker !=0 )
        {
            if (TWI_operation == FALSE) 
            {
              global_marker = 0;   my_marker = 0;
            }
        }
    }
}
/******************************************************************************/
void Opto_Upr(void)
{
// for U3
  static unsigned char   my_marker;

    if (global_marker == 0)
    {
        if ((PINA & 0x02) == 0)
        {
          global_marker = 1;
          my_marker = 1;
          TWI_targetSlaveAddress = SLA_W_DIO;
          command_twi = RD_TWI_SLAVE;
          number_byte_wr_slave = 2;
          number_byte_rd_slave = 2;
          byte_addr_comm = 0x01;
        }
    }

    else
    {
        if (my_marker !=0 )
        {
            if (TWI_operation == FALSE) 
            {
              global_marker = 0;   my_marker = 0;
            }
        }
    }
}
