#include <inavr.h>
#include <iom8.h>
#include "adc_dio.h"
#include "TWI_Slave.h"

/********************************************************************************
*                                                                               *
*********************************************************************************
*                                                                               *
********************************************************************************/
uchar TWI_Act_On_Failure_In_Last_Transmission ( uchar TWIerrorMsg )
{
    TWI_Start_Transceiver();
    return TWIerrorMsg; 
}
/*******************************************************************************
*                                                                              *
*******************************************************************************/
void Main_Prog_DIO (void)
{
}
/*******************************************************************************
*        MAIN                                                                  *
*******************************************************************************/
void main (void)
{
  uchar   message_buf[TWI_BUFFER_SIZE];
  uchar   TWI_slaveAddress;

    PORTC = 0x0F;
    DDRC  = 0x0F;

    cmd_i2c = 0;

    TWI_slaveAddress = SLA_W_DIO;

    TWI_Slave_Initialise( (TWI_slaveAddress) | (TRUE<<TWI_GEN_BIT) );
                                                                                  
    __enable_interrupt();

    TWI_Start_Transceiver();

    for(;;)
    {    
        if ( ! TWI_Transceiver_Busy() )
        {
            if ( TWI_statusReg.lastTransOK )
            {
                if ( TWI_statusReg.RxDataInBuf )
                {
                  TWI_Get_Data_From_Transceiver(message_buf, DATA_BUF);         

                    if ( TWI_statusReg.genAddressCall )
                    {
                      //              
                    }

                    else
                    {
                      cmd_i2c = message_buf[0];

                        switch (cmd_i2c)
                        {
                          case 1:
                            message_buf[0] = byte_in;
                            TWI_Start_Transceiver_With_Data( message_buf, 1 );
                          break; 
                        }
                    }
                }

                else
                {
                  __no_operation();
                }

                if ( ! TWI_Transceiver_Busy() )
                {
                  TWI_Start_Transceiver();
                }      
            }

            else
            {
              TWI_Act_On_Failure_In_Last_Transmission( TWI_Get_State_Info() );
            }
        }

        Main_Prog_DIO();

    }
}
